#!/usr/bin/perl
# Serge Sharoff, based on the original version of Marco Baroni

use strict;
use warnings;
my ($charset, $encoding, $fname, $header, $text, @fnames);
@fnames=<>;

$/="<\/head>";  # but $/ can't be case-insensitive

foreach $fname (@fnames) {
#    chomp($fname);
    $fname=~s/[\x0A\x0D]+$//; #to deal with DOS file lists
    next if (-d $fname); # skip directories
    if (open(IN,$fname)) {
	$text=<IN>;
	close(IN);
	if ($text=~/<\/head>/i) {
	    $header=$`;  # this slows pattern matching slightly, but otherwise /(.+)<\/head>/si takes ages on large files lacking a header
	} else {
	    $header=$text;
	};
	if (($charset)=$header=~/charset=(.+?)[\"<>]/i) {
	    $charset=lc($charset);
	    $charset=~s/[\\\/\$<>]+/-/g;
	    $encoding=($charset =~/(?:win|cp|an).*(125\d)/) ? "cp-$1" : # frequently win or cp or ansi
		($charset =~/(?:cp|ibm).*([78]\d\d)/) ? "dos-$1" : # DOS encodings, e.g. cp866
		($charset =~/iso.*(8859[\d-]+|646[\w.]+)/) ? "iso-$1" : 
		($charset =~/utf.*8/) ? "utf8" :
		($charset =~/(utf.*16|unicode)/) ? "utf16" :
		($charset =~/koi.*8/) ? "koi8" : # Cyrillic
		($charset =~/gb.*2312/) ? "gb2312" : # Chinese simplified
		($charset =~/(?:win|cp).*936/) ? "cp936" : # Chinese simplified (superset of 2312)
		($charset =~/gb.*18030/) ? "gb18030" : # Chinese simplified (superset of 2312)
		($charset =~/^hz.*/) ? "hz" : # Chinese simplified, 7-bit
		($charset =~/gbk/) ? "gbk" : # Chinese simplified
		($charset =~/iso.*2022/) ? "iso-2022" : 
		($charset =~/big-?5/) ? "big5" : # Chinese traditional
		($charset =~/euc.*cn/) ? "euc-cn" : #Chinese
		($charset =~/.*s.*jis/) ? "shiftjis" : # Japanese
		($charset =~/euc.*jp/) ? "euc-jp" : #Japanese
		($charset =~/euc.*kr/) ? "euc-kr" : #Korean
		"unknown-charset";
	} else {
	    $encoding= 'unset';
	};
	print "$fname\t$encoding\n";
    } else {
	print STDERR "Cannot open $fname, skipped: $!\n" if $fname=~/\S/;
    };
}
